# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


import gtk

import service
import common
from widget.view import common_gtk

class Image(object):
    def __init__(self, field_name, treeview=None, attrs=None, window=None):
        self.field_name = field_name
        self.attrs = attrs or {}
        self.renderer = gtk.CellRendererPixbuf()
        self.editable = attrs.get('editable',False)
        self.height = int(attrs.get('img_height', 33))
        self.width = int(attrs.get('img_width', 100))
        self.treeview = treeview
        if not window:
            window = service.LocalService('gui.main').window
        self.window = window
        self.pixbuf_cache = {} # warning caching consequence is memory eated.
    
    def setter(self, column, cell, store, iter):
        model_record = store.get_value(iter, 0)
        resource = model_record.resource
        resource_id = model_record.id
        field_name = column.name
        thumbnail = common_gtk.get_thumbnail(resource, field_name, 
                                             resource_id, self.width, 
                                             self.height)
        
        cell.set_property('pixbuf', thumbnail)

    def open_remote(self, model, create, changed=False, text=None):
        raise NotImplementedError
    
    def _get_data(self, model_record):
        return model_record[self.field_name].get_client(model_record)

    def get_textual_value(self, model):
        return ''

    def value_from_text(self, model, text):
        return text